#!/usr/bin/env python3


import re
import sys

def main(syscall_h, output=None, exclude=None):
    # find syscalls
    pattern = re.compile('#define +__NR_(?P<syscall>\w+) +(?P<nr>\d+)')
    syscalls = {}
    with open(syscall_h) as f:
        for line in f:
            m = pattern.search(line)
            if m:
                syscalls[int(m.group('nr'))] = m.group('syscall')
    print('found %d syscalls, min %d, max %d' % (
        len(syscalls), min(syscalls.keys()), max(syscalls.keys())))
    syscall_count = max(syscalls.keys()) + 1

    # find which syscalls are already defined in our exclude file
    excludes = set()
    if exclude:
        pattern = re.compile('__elrond_sys0_(?P<syscall>\w+)')
        with open(exclude) as f:
            for line in f:
                m = pattern.search(line)
                if m:
                    excludes.add(m.group('syscall'))
        print('excluding %d syscalls' % len(excludes))

    # write our output
    if output:
        with open(output, 'w') as f:
            def writeln(s=''):
                f.write(s)
                f.write('\n')
            f.writeln = writeln

            f.writeln('// Generated by %s:' % sys.argv[0])
            f.writeln('//')
            f.writeln('// %s' % ' '.join(sys.argv))
            f.writeln('//')
            f.writeln()

            # some includes
            f.writeln('#include <stdarg.h>')
            f.writeln('#include <errno.h>')
            f.writeln('#include <syscall.h>')
            f.writeln()

            # create the default syscall
            f.writeln('long __elrond_sys0_default(va_list args) {')
            f.writeln('    return -ENOSYS;')
            f.writeln('}')
            f.writeln('__attribute__((weak, alias("__elrond_sys0_default")))')
            f.writeln('long __elrond_sys_default(va_list args);')
            f.writeln()

            # create both weak and non-weak aliases for syscalls
            for _, syscall in sorted(syscalls.items()):
                if syscall in excludes:
                    f.writeln('extern long __elrond_sys0_%s(va_list args);' % syscall)
                    f.writeln('__attribute__((weak))')
                    f.writeln('long __elrond_sys_%s(va_list args) {' % syscall)
                    f.writeln('    return __elrond_sys0_%s(args);' % syscall)
                    f.writeln('}')
                    f.writeln()
                else:
                    f.writeln('__attribute__((alias("__elrond_sys0_default")))')
                    f.writeln('long __elrond_sys0_%s(va_list args);' % syscall)
                    f.writeln('__attribute__((weak, alias("__elrond_sys0_%s")))' % syscall)
                    f.writeln('long __elrond_sys_%s(va_list args);' % syscall)
                    f.writeln()

            # create table of syscalls
            f.writeln('long __elrond_syscall_count = %d;' % syscall_count)
            f.writeln('long (*__elrond_syscalls[%d])(va_list args) = {' % syscall_count)
            for nr, syscall in sorted(syscalls.items()):
                f.writeln('    /* %d */ [__NR_%s] = __elrond_sys_%s,' % (
                    nr, syscall, syscall))
            f.writeln('};')


if __name__ == "__main__":
    import argparse
    import sys
    parser = argparse.ArgumentParser(
        description="Generates a C source file with the default weak \
            __elrond_sys_* symbols based on a given musl's syscall.h.")
    parser.add_argument('syscall_h',
        help="File to parse for syscall #defines.")
    parser.add_argument('-o', '--output',
        help=".c file to write.")
    parser.add_argument('-x', '--exclude',
        help="Another .c file containing syscalls we don't want default weak \
            symbols for, most likely because they are declared weak in a \
            different file.")
    sys.exit(main(**{k: v
        for k, v in vars(parser.parse_args()).items()
        if v is not None}))
    
